--[[
	Description: Titan plug-in to display Garrison Resources level
	Author: Tabethial, based on Subwired's excellent addons
--]]

local ProfName = "Garrison Resources"
local menutext = "Titan|cF58CBA00 "..ProfName.."|r"
local buttonlabel = ProfName..": "
local ID = "GR"
local elap, GR, prevGR = 0, 0.0, -2
local GRmax, preGRmax = 0, 0



-- Main button frame and addon base
local f = CreateFrame("Button", "TitanPanelGRButton", CreateFrame("Frame", nil, UIParent), "TitanPanelComboTemplate")
f:SetFrameStrata("FULLSCREEN")
f:SetScript("OnEvent", function(this, event, ...) this[event](this, ...) end)
f:RegisterEvent("ADDON_LOADED")

f:SetScript("OnClick", function(self, button, down)
--local prof = ProfName
--if prof == "Mining" then prof = "Smelting" end
--if prof == "FirstAid" then prof = "First Aid" end
--CastSpellByName(prof)
end)

function f:ADDON_LOADED(a1)

--print ("a1 = " .. a1)
	if a1 ~= "TitanGarrisonResources" then 
		return 
	end
	
	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil
	
	self.registry = {
		id = ID,
		menuText = menutext,
		buttonTextFunction = "TitanPanelGRButton_GetButtonText",
		tooltipTitle = ID,
		tooltipTextFunction = "TitanPanelGRButton_GetTooltipText",
		frequency = 1,
		icon = "Interface\\Icons\\Garrison_bronzechest.blp",
		iconWidth = 16,
		category = "Information",
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = false,
			--http://www.wowwiki.com/File:Garrison_bronzechest.png?action=edit&redlink=1
		},
	}
	self:SetScript("OnUpdate", function(this, a1)
		elap = elap + a1
		if elap < 1 then return end

		--local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
		--local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier = GetProfessionInfo(index)
	     
		local name, currentAmount, texture, earnedThisWeek, weeklyMax, totalMax, isDiscovered = GetCurrencyInfo(824);
	
		GR = currentAmount
		GRmax = totalMax
		
		if GR == prevGR and GRmax == preGRmax then 
			return 
		end
		
		preGRmax = GRmax
		prevGR  = GR
		TitanPanelButton_UpdateButton(ID)
		elap = 0
	end)
		
	--TitanPanelButton_OnLoad(self)
end

----------------------------------------------
function TitanPanelGRButton_GetButtonText()
----------------------------------------------
	local GRtext, pitchtext
	if not GR then
		GRtext = "??"
	else
	
		GRtext = GR .."/"..GRmax--string.format("%.0f", GR)  
	end
	return buttonlabel, GRtext
end

-----------------------------------------------
function TitanPanelGRButton_GetTooltipText()
-----------------------------------------------
	return "Displays your current number of Garrison Resources"
end

local temp = {}
local function UIDDM_Add(text, func, checked, keepShown)
	temp.text, temp.func, temp.checked, temp.keepShownOnClick = text, func, checked, keepShown
	UIDropDownMenu_AddButton(temp)
end
----------------------------------------------------
function TitanPanelRightClickMenu_PrepareGRMenu()
----------------------------------------------------
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[ID].menuText)
	
	TitanPanelRightClickMenu_AddToggleIcon(ID)
	TitanPanelRightClickMenu_AddToggleLabelText(ID)
	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, ID, TITAN_PANEL_MENU_FUNC_HIDE)
end